IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRCoolixAC Class Reference

Class for handling detailed Coolix A/C messages. More...

`#include <ir_Coolix.h>`

Collaboration diagram for IRCoolixAC:
[legend]

## Public Member Functions
| IRCoolixAC (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | send (const uint16_t repeat=kCoolixDefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setTemp (const uint8_t temp)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setSensorTemp (const uint8_t temp)
| Set the sensor temperature. More...
uint8_t | getSensorTemp (void) const
| Get the sensor temperature setting. More...
void | clearSensorTemp (void)
| Clear the Sensor Temperature setting.. More...
void | setFan (const uint8_t speed, const bool modecheck=true)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setSwing (void)
| Toggle the Swing mode of the A/C. More...
bool | getSwing (void) const
| Get the Swing setting of the A/C. More...
void | setSwingVStep (void)
| Set the Vertical Swing Step setting of the A/C. More...
bool | getSwingVStep (void) const
| Get the Vertical Swing Step setting of the A/C. More...
void | setSleep (void)
| Toggle the Sleep mode of the A/C. More...
bool | getSleep (void) const
| Get the Sleep setting of the A/C. More...
void | setTurbo (void)
| Toggle the Turbo mode of the A/C. More...
bool | getTurbo (void) const
| Get the Turbo setting of the A/C. More...
void | setLed (void)
| Toggle the Led (light) mode of the A/C. More...
bool | getLed (void) const
| Get the Led (light) setting of the A/C. More...
void | setClean (void)
| Toggle the Clean mode of the A/C. More...
bool | getClean (void) const
| Get the Clean setting of the A/C. More...
bool | getZoneFollow (void) const
| Get the Zone Follow setting of the A/C. More...
uint32_t | getRaw (void) const
| Get a copy of the internal state as a valid code for this protocol. More...
void | setRaw (const uint32_t new_code)
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (const stdAc::state_t *prev=NULL) const
| Convert the A/C state to it's common stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the internal state into a human readable string. More...
void | setZoneFollow (const bool on)
| Change the Zone Follow setting. More...

## Static Public Member Functions
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a standard A/C mode into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode to it's common stdAc::opmode_t equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions
void | setTempRaw (const uint8_t code)
| Set the raw (native) temperature value. More...
uint8_t | getTempRaw (void) const
| Get the raw (native) temperature value. More...
void | setSensorTempRaw (const uint8_t code)
| Set the raw (native) sensor temperature value. More...
bool | isSpecialState (void) const
| Is the current state is a special state? More...
bool | handleSpecialState (const uint32_t data)
| Adjust any internal settings based on the type of special state we are supplied. Does nothing if it isn't a special state. More...
void | updateAndSaveState (const uint32_t raw_state)
| Backup the current internal state as long as it isn't a special state and set the new state. More...
void | recoverSavedState (void)
| Restore the current internal state from backup as long as it isn't a special state. More...
uint32_t | getNormalState (void)

## Private Attributes
IRsend | _irsend
| Instance of the IR send class. More...
CoolixProtocol | _
| The state of the IR remote in IR code form. More...
CoolixProtocol | _saved
| Copy of the state if we required a special mode. More...
bool | powerFlag
bool | turboFlag
bool | ledFlag
bool | cleanFlag
bool | sleepFlag
bool | swingFlag
uint8_t | savedFan

## Detailed Description

Class for handling detailed Coolix A/C messages.

See also
  https://github.com/crankyoldgit/IRremoteESP8266/issues/484

## Constructor & Destructor Documentation

## ◆ IRCoolixAC()

IRCoolixAC::IRCoolixAC | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |
| explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRCoolixAC::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calibrate()

int8_t IRCoolixAC::calibrate | ( | void |  | ) |
| inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ clearSensorTemp()

void IRCoolixAC::clearSensorTemp | ( | void |  | ) |

Clear the Sensor Temperature setting..

## ◆ convertFan()

uint8_t IRCoolixAC::convertFan | ( | const stdAc::fanspeed_t | speed | ) |
| static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRCoolixAC::convertMode | ( | const stdAc::opmode_t | mode | ) |
| static

Convert a standard A/C mode into its native mode.

Parameters

  [in] | mode | A stdAc::opmode_t to be converted to it's native equivalent.

Returns
  The corresponding native mode.

## ◆ getClean()

bool IRCoolixAC::getClean | ( | void |  | ) | const

Get the Clean setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getFan()

uint8_t IRCoolixAC::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed.

## ◆ getLed()

bool IRCoolixAC::getLed | ( | void |  | ) | const

Get the Led (light) setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getMode()

uint8_t IRCoolixAC::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getNormalState()

uint32_t IRCoolixAC::getNormalState | ( | void |  | ) |
| private

## ◆ getPower()

bool IRCoolixAC::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

Note
  There is only an "off" state. Everything else is "on".

## ◆ getRaw()

uint32_t IRCoolixAC::getRaw | ( | void |  | ) | const

Get a copy of the internal state as a valid code for this protocol.

Returns
  A valid code for this protocol based on the current internal state.

## ◆ getSensorTemp()

uint8_t IRCoolixAC::getSensorTemp | ( | void |  | ) | const

Get the sensor temperature setting.

Returns
  The current setting for sensor temp. in degrees celsius.

## ◆ getSleep()

bool IRCoolixAC::getSleep | ( | void |  | ) | const

Get the Sleep setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwing()

bool IRCoolixAC::getSwing | ( | void |  | ) | const

Get the Swing setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwingVStep()

bool IRCoolixAC::getSwingVStep | ( | void |  | ) | const

Get the Vertical Swing Step setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getTemp()

uint8_t IRCoolixAC::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## ◆ getTempRaw()

uint8_t IRCoolixAC::getTempRaw | ( | void |  | ) | const
| private

Get the raw (native) temperature value.

Returns
  The native temperature value.

## ◆ getTurbo()

bool IRCoolixAC::getTurbo | ( | void |  | ) | const

Get the Turbo setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getZoneFollow()

bool IRCoolixAC::getZoneFollow | ( | void |  | ) | const

Get the Zone Follow setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ handleSpecialState()

bool IRCoolixAC::handleSpecialState | ( | const uint32_t | data | ) |
| private

Adjust any internal settings based on the type of special state we are supplied. Does nothing if it isn't a special state.

Parameters

  [in] | data | The state we need to act upon.

Note
  Special state means commands that are not affecting Temperature/Mode/Fan, and they toggle a setting. e.g. Swing Step is not a special state by this definition.

Returns
  true, if it is a special state. false if it isn't.

## ◆ isSpecialState()

bool IRCoolixAC::isSpecialState | ( | void |  | ) | const
| private

Is the current state is a special state?

Returns
  true, if it is. false if it isn't.

## ◆ off()

void IRCoolixAC::off | ( | void |  | ) |

Change the power setting to Off.

## ◆ on()

void IRCoolixAC::on | ( | void |  | ) |

Change the power setting to On.

## ◆ recoverSavedState()

void IRCoolixAC::recoverSavedState | ( | void |  | ) |
| private

Restore the current internal state from backup as long as it isn't a special state.

## ◆ send()

void IRCoolixAC::send | ( | const uint16_t | repeat = `kCoolixDefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setClean()

void IRCoolixAC::setClean | ( | void |  | ) |

Toggle the Clean mode of the A/C.

## ◆ setFan()

void IRCoolixAC::setFan | ( | const uint8_t | speed,
|  | const bool | modecheck = `true`
| ) |  |

Set the speed of the fan.

Parameters

  [in] | speed | The desired setting.
  [in] | modecheck | Do we enforce any mode limitations before setting?

## ◆ setLed()

void IRCoolixAC::setLed | ( | void |  | ) |

Toggle the Led (light) mode of the A/C.

## ◆ setMode()

void IRCoolixAC::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setPower()

void IRCoolixAC::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRCoolixAC::setRaw | ( | const uint32_t | new_code | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.

## ◆ setSensorTemp()

void IRCoolixAC::setSensorTemp | ( | const uint8_t | temp | ) |

Set the sensor temperature.

Parameters

  [in] | temp | The temperature in degrees celsius.

Warning
  Do not send messages with a Sensor Temp more frequently than once per minute, otherwise the A/C unit will ignore them.

## ◆ setSensorTempRaw()

void IRCoolixAC::setSensorTempRaw | ( | const uint8_t | code | ) |
| private

Set the raw (native) sensor temperature value.

Note
  Bypasses any checks or additional actions.

Parameters

  [in] | code | The desired native sensor temperature.

## ◆ setSleep()

void IRCoolixAC::setSleep | ( | void |  | ) |

Toggle the Sleep mode of the A/C.

## ◆ setSwing()

void IRCoolixAC::setSwing | ( | void |  | ) |

Toggle the Swing mode of the A/C.

## ◆ setSwingVStep()

void IRCoolixAC::setSwingVStep | ( | void |  | ) |

Set the Vertical Swing Step setting of the A/C.

## ◆ setTemp()

void IRCoolixAC::setTemp | ( | const uint8_t | desired | ) |

Set the temperature.

Parameters

  [in] | desired | The temperature in degrees celsius.

## ◆ setTempRaw()

void IRCoolixAC::setTempRaw | ( | const uint8_t | code | ) |
| private

Set the raw (native) temperature value.

Note
  Bypasses any checks.

Parameters

  [in] | code | The desired native temperature.

## ◆ setTurbo()

void IRCoolixAC::setTurbo | ( | void |  | ) |

Toggle the Turbo mode of the A/C.

## ◆ setZoneFollow()

void IRCoolixAC::setZoneFollow | ( | const bool | on | ) |

Change the Zone Follow setting.

Note
  Internal use only.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ stateReset()

void IRCoolixAC::stateReset | ( | void |  | ) |

Reset the internal state to a fixed known good state.

## ◆ toCommon()

stdAc::state_t IRCoolixAC::toCommon | ( | const stdAc::state_t * | prev = `NULL` | ) | const

Convert the A/C state to it's common stdAc::state_t equivalent.

Parameters

  [in] | prev | Ptr to the previous state if required.

Returns
  A stdAc::state_t state.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRCoolixAC::toCommonFanSpeed | ( | const uint8_t | speed | ) |
| static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRCoolixAC::toCommonMode | ( | const uint8_t | mode | ) |
| static

Convert a native mode to it's common stdAc::opmode_t equivalent.

Parameters

  [in] | mode | A native operation mode to be converted.

Returns
  The corresponding common stdAc::opmode_t mode.

## ◆ toString()

String IRCoolixAC::toString | ( | void |  | ) | const

Convert the internal state into a human readable string.

Returns
  The current internal state expressed as a human readable String.

> See also
>   https://github.com/crankyoldgit/IRremoteESP8266/issues/1639#issuecomment-944906016

## ◆ updateAndSaveState()

void IRCoolixAC::updateAndSaveState | ( | const uint32_t | raw_state | ) |
| private

Backup the current internal state as long as it isn't a special state and set the new state.

Note
  : Must be called before every special state to make sure the internal state is safe.

Parameters

  [in] | raw_state | A valid raw state/code for this protocol.

## Member Data Documentation

## ◆ _

CoolixProtocol IRCoolixAC::_
| private

The state of the IR remote in IR code form.

## ◆ _irsend

IRsend IRCoolixAC::_irsend
| private

Instance of the IR send class.

## ◆ _saved

CoolixProtocol IRCoolixAC::_saved
| private

Copy of the state if we required a special mode.

## ◆ cleanFlag

bool IRCoolixAC::cleanFlag
| private

## ◆ ledFlag

bool IRCoolixAC::ledFlag
| private

## ◆ powerFlag

bool IRCoolixAC::powerFlag
| private

## ◆ savedFan

uint8_t IRCoolixAC::savedFan
| private

## ◆ sleepFlag

bool IRCoolixAC::sleepFlag
| private

## ◆ swingFlag

bool IRCoolixAC::swingFlag
| private

## ◆ turboFlag

bool IRCoolixAC::turboFlag
| private

The documentation for this class was generated from the following files:

- src/ir_Coolix.h
- src/ir_Coolix.cpp